<script lang="ts">
import { MetaInfo } from 'vue-meta/types/vue-meta';
import { getPageMetadata } from '~/common/meta';
import { CONTENT_TYPES } from '~/common/content-types';
import { getClient } from '~/plugins/contentful.js';
import { SolutionsResourceCards } from '~/components/solutions/index.vue';
import {
  CodeSuggestionsSalesContent,
  CodeSuggestionsSalesHero,
} from '~/components/solutions/code-suggestions/sales/index.vue';
import { GDSalesHelper } from '~/services/solutions/gitlab-duo-sales.service';
import { convertToCaseSensitiveLocale } from '~/common/util';

export default {
  name: 'CodeSuggestions',
  components: {
    CodeSuggestionsSalesContent,
    CodeSuggestionsSalesHero,
    SolutionsResourceCards,
  },
  layout: 'code-suggestions-sale',
  async asyncData({ i18n }) {
    try {
      const content = await getClient()
        .getEntries({
          content_type: CONTENT_TYPES.PAGE,
          include: 10,
          'fields.slug': 'solutions/gitlab-duo-pro/sales',
          locale: convertToCaseSensitiveLocale(i18n.locale),
        })
        .then((query: any) => {
          const entryFields = query.items[0]?.fields;
          return GDSalesHelper(entryFields);
        });
      return { content };
    } catch (e) {
      throw new Error(e);
    }
  },
  data() {
    let param = null;
    const selectedTab = 'gitlab-duo-pro';

    if (this.$route.query.type) {
      param = this.$route.query.type;
    }

    return {
      submitted: false,
      param,
      selectedTab,
    };
  },
  head(): MetaInfo {
    return {
      ...getPageMetadata(
        (this as any).content,
        this.$route.path,
        this.$nuxtI18nHead({ addSeoAttributes: true }),
      ),
    };
  },
  mounted() {
    this.$nuxt.$on('submit', () => {
      this.submitted = true;
    });
  },
  methods: {
    onFormSubmit() {
      this.$nuxt.$emit('submit');
      this.submitted = true;
      this.$refs.targetRef.scrollIntoView({ behavior: 'smooth' });
    },

    isActive(tabId) {
      return this.selectedTab === tabId;
    },
  },
};
</script>
<template>
  <div ref="targetRef" class="code-suggestions-sales">
    <TransitionGroup v-if="!submitted" name="content" tag="div">
      <div key="hero">
        <CodeSuggestionsSalesHero
          v-if="content.duoCombinedHero"
          :data="content.duoCombinedHero"
        />
      </div>

      <CodeSuggestionsSalesContent
        key="content"
        :form-tabs="content.formTabs"
        :param="param"
        :cards="content.cards"
        @submit="onFormSubmit"
      />
    </TransitionGroup>
    <TransitionGroup v-if="submitted" name="content" tag="div">
      <CodeSuggestionsSalesHero
        v-if="content.submittedHero"
        key="hero"
        :data="content.submittedHero"
      />
      <SolutionsResourceCards
        v-if="content.resources"
        v-bind="content.resources"
        key="resources"
      />
    </TransitionGroup>
  </div>
</template>

<style lang="scss" scoped>
.code-suggestions-sales {
  overflow: hidden;
  position: relative;
}

.toggle-buttons-container {
  position: absolute;
  margin-top: $spacing-64;
  z-index: 1;
  width: fit-content;
  left: 50%;
  transform: translateX(-50%);

  @media (max-width: $breakpoint-lg) {
    margin-top: $spacing-32;
  }

  .toggle-buttons {
    position: relative;
    border: $border;
    border-radius: 90px;
    align-items: center;
    display: flex;
    white-space: nowrap;
    line-height: $line-height-button-1;
    &:after {
      background: linear-gradient(
          89.09deg,
          #e1986d -1.12%,
          #7759c2 102.06%,
          #6e43d3 102.07%
        )
        border-box;
      border: 1.5px solid transparent;
      border-radius: 90px;
      bottom: -1px;
      content: '';
      left: -1px;
      -webkit-mask:
        linear-gradient(#fff, #fff 0) padding-box,
        linear-gradient(#fff, #fff 0);
      -webkit-mask:
        linear-gradient(#fff 0 0) padding-box,
        linear-gradient(#fff 0 0);
      -webkit-mask-composite: xor;
      mask-composite: exclude;
      position: absolute;
      right: -1px;
      top: -1px;
    }
    span {
      padding: $spacing-16;
      border-radius: 90px;
      color: $color-text-50;
      z-index: 2;
      &.active {
        background-color: #362738;
        font-weight: 600;
        padding: $spacing-16 !important;
      }
      &:hover {
        cursor: pointer;
      }
    }
  }
}
.content-move, /* apply transition to moving elements */
.content-enter-active,
.content-leave-active {
  transition: all 0.5s ease;
}

.content-enter-from,
.content-leave-to {
  opacity: 0;
}
.content-leave-to {
  transform: translateY(100%);
}
/* ensure leaving items are taken out of layout flow so that moving
   animations can be calculated correctly. */
.content-leave-active {
  position: absolute;
  left: 0;
  top: 0;
  width: 100%;
}
</style>
